import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _get from 'babel-runtime/helpers/get';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import Select from 'react-select';
import TetherComponent from 'react-tether';

/** from https://github.com/JedWatson/react-select/issues/810#issuecomment-250274937 **/

var TetheredSelectWrap = function (_Select) {
  _inherits(TetheredSelectWrap, _Select);

  function TetheredSelectWrap(props) {
    _classCallCheck(this, TetheredSelectWrap);

    var _this = _possibleConstructorReturn(this, (TetheredSelectWrap.__proto__ || _Object$getPrototypeOf(TetheredSelectWrap)).call(this, props));

    _this.renderOuter = _this._renderOuter;
    return _this;
  }

  _createClass(TetheredSelectWrap, [{
    key: '_renderOuter',
    value: function _renderOuter() {
      var menu = _get(TetheredSelectWrap.prototype.__proto__ || _Object$getPrototypeOf(TetheredSelectWrap.prototype), 'renderOuter', this).apply(this, arguments);
      // Don't return an updated menu render if we don't have one
      if (!menu) {
        return;
      }
      /** this.wrapper comes from the ref of the main Select component (super.render()) **/
      var selectWidth = this.wrapper ? this.wrapper.offsetWidth : null;
      return React.createElement(
        TetherComponent,
        {
          renderElementTo: '.react-virtualized-mount-node',
          ref: 'tethered-component',
          attachment: 'top left',
          targetAttachment: 'top left',
          constraints: [{
            to: 'window',
            attachment: 'together',
            pin: ['top']
          }]
        },
        React.createElement('div', null),
        React.cloneElement(menu, { style: { position: 'static', width: selectWidth } })
      );
    }
  }]);

  return TetheredSelectWrap;
}(Select);

export default TetheredSelectWrap;